<!-- Пока непонятно какие данные динамиччны. Сделал только адрес и картинки. 
Ну и по стилям подумать о переполнении количества городов в строке. Пка overflow auto;  -->

<template>
    <section class="section section-map">
        <div class="container">
            <select-city @itemsVisibleChanged="itemsVisibleChanged" :items="items_"></select-city>
            <div class="map-wrap row">
                <div class="map__description col-md-5">
                    <div class="map__address map__description-row">
                        <div class="map__title">Адрес:</div>
                        <p class="map__content">{{ mapAddress }}</p>
                    </div>
                    <div class="map__record map__description-row"> 
                        <div
                            class="map__title"
                        >Записаться на тренинги, консультации и задать интересующие вопросы по телефону:</div>
                        <p class="map__content">
                        	<a href="#" class="color-pink"><b>8(800) 555-55-55</b></a><br>
                        	<a href="#" class="color-pink"><b>8(800) 555-55-55</b></a><br>
                        	C 12:00 до 21:00 по московскому времени
                        </p>
                    </div>
                    <div class="map__description-row">
                        <div class="map__title">Наши Email адреса:</div>
                        <p class="map__content">
                            Очное отделение: <a href="#" class="color-pink">info@bronnikov.ru</a><br>
							Дистанционное обучение: <a href="#" class="color-pink">info@bronnikov.ru</a><br>
							Сотрудничество и выездные тренинги: <a href="#" class="color-pink">info@bronnikov.ru</a>
                        </p>
                    </div>
                    <div class="map__description-row">
						<div class="map__content">	
							Портал дистанционного обучения <a href="#" class="color-pink">neoludi.ru</a></div>
						</div>	
                </div>
                <div class="map__right col-md-7">
                    <div id="map"></div>
                </div>
            </div>
            <div class="map-images row" v-if="mapImages">
				<div class="col-md-4" v-for="(image, index) in mapImages" :key="index">
                	<img  :src="image" alt>
				</div>
            </div>
        </div>
    </section>
</template>

<script>
import Samples from "../../samples.js";

import each from "lodash-es/each";
import size from "lodash-es/size";
import map from "lodash-es/map";
import cloneDeep from "lodash-es/cloneDeep"; 

export default {
    props: {
        items: {
            default: () => Samples.load('points')
        },
        zoom: {
            type: Number,
            default: 10
        }
    },
    data() {
        return {
            mapImages: null,
            mapAddress: null,
            items_: map(this.items, (item) => {
                if (size(item.position)) {
                    item.position.lat = parseFloat(item.position.lat);
                    item.position.lng = parseFloat(item.position.lng);
                }
                return item;
            }),
            map: null,
            currentMarkers: [],
            markerCluster: null,
            itemsVisible: null
        };
    },
    methods: {
        itemsVisibleChanged: function(items) {
            this.itemsVisible = items;
            if (typeof google === "object" && typeof google.maps === "object") {
                this.setMarkers(items);
            }
        },

        itemSelected: function(index) {
            var activePlace = this.items_[index],
                marker = activePlace.marker;

            this.map.panTo(marker.getPosition());
        },
        showPoint: function(point) {
            this.mapImages = point.images;
        },
        addMyMarkers: function(items) {
            each(items, (item, index) => {
                item["marker"] = new google.maps.Marker({
                    position: item.position,
                    label: {
                        text: (parseInt(index) + 1).toString(),
                        color: "#fff",
                        fontSize: "14px",
                        fontWeight: "bold",
                        fontFamily: "Circe"
                    },
                    icon: {
                        path: "M99.144,0A13.813,13.813,0,0,0,86.991,20.374l11.4,20.614a.863.863,0,0,0,1.511,0l11.4-20.62A13.813,13.813,0,0,0,99.144,0Zm0,20.717a6.905,6.905,0,1,1,6.905-6.905A6.913,6.913,0,0,1,99.144,20.717Z",
                        fillColor: "#694EB2",
                        fillOpacity: 1,
                        scale: 1,
                        strokeWeight: 1,
                        strokeColor: "#000",
                        strokeOpacity: 0.3
                    },
                    zIndex: 1,
                    map: this.map
                });
                item["marker"].addListener("click", e => {
                    this.mapImages = item.images;
                    this.mapAddress = item.address;
                });
                this.currentMarkers.push(item);
            });
        },
        rebuildMarkers: function(items) {
            this.addMyMarkers(items);
            this.mapAddress = items[0].address;
            if (typeof items[0].images) this.mapImages = items[0].images;
            this.mapAddress = items[0].address;
        },

        setMarkers: function(items) {
            // console.log(items_);
            // Очищаем карту от маркеров
            each(map(this.currentMarkers, "marker"), marker => {
                marker.setMap(null);
            });
            this.rebuildMarkers(items);

            // Центровка на первом элементе при смене города
            this.selectedPlace = 0;
            var newActivePlace = this.itemsVisible[0].marker;
            this.map.panTo(newActivePlace.getPosition());

            // Перерисовка маркеров  при смене города

            // Обновляем массив маркеров в библиотеке кластеризации маркеров
            // var markers = _.map(this.itemsVisible, 'marker');
            // this.markerCluster.clearMarkers();
            // this.markerCluster.addMarkers(markers);

            //Автозум на массиве отображаемых точек
            // var bounds = new google.maps.LatLngBounds ();
            // _.each(_.map(this.itemsVisible, 'position'), (position) => {
            //     bounds.extend(new google.maps.LatLng (position.lat, position.lng));
            // });
            // this.map.fitBounds(bounds);
        }
    },
    mounted() {
        this.itemsVisible = cloneDeep(this.items_);

        // Первая проверка на существования googe.maps
        if (!(typeof google === "object" && typeof google.maps === "object")) {
            // Добавляем скрипт кластеризации
            let script_claster = document.createElement("script");
            script_claster.src =
                "https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js";
            script_claster.type = "text/javascript";
            document
                .getElementsByTagName("head")[0]
                .appendChild(script_claster);

            // грузим карту потом допилить получение ключа с сайта
            let script_map = document.createElement("script");
            script_map.src =
                "https://maps.googleapis.com/maps/api/js?key=AIzaSyDVoZ3Va6NUK68JJv55BloogpfwRAoIgwo&callback=googleMapLoaded";
            script_map.type = "text/javascript";
            document.getElementsByTagName("head")[0].appendChild(script_map);
        }
        document.addEventListener("google-map-loaded", () => {
            // объявление карты
            this.map = new google.maps.Map(document.getElementById("map"), {
                zoom: this.zoom,
                center: this.items_[0].position,
                disableDefaultUI: true
            });
            // добавление маркеров
            this.rebuildMarkers(this.itemsVisible);
        });
    }
};
</script>